#include <bits/stdc++.h>
using namespace std;
typedef pair<int, int> pii;

struct S {
    int left, right, used;
    bool operator < (const S &s) const {
        return left < s.left || (left == s.left && right < s.right)
        || (left == s.left && right == s.right && used < s.used);
    }
};
map<S, int> dp;

int find(int left, int right, vector<int> &a, int used,
         vector<int> &colors) {
    if (dp.count({ left, right, used })) return dp[{ left, right, used }];
    if (right - left == 1) {
        if (a[left] == used) return 0;
        else return 1;
    }
    int mid = (left + right) / 2;
    int ans = find(left, mid, a, used, colors) + find(mid, right, a, used, colors);
    map<int, int> cnt;
    for (int i = 0; i < colors.size(); i++) {
        ans = min(ans, 1 + find(left, mid, a, colors[i], colors)
                  + find(mid, right, a, colors[i], colors));
    }
    return dp[{ left, right, used }] = ans;
}
int stsolve(int k, vector<int> &c, vector<int> &v) {
    vector<int> a(1 << k);
    for (int i = 0, cur = 0; i < v.size(); i++) {
        for (int j = 0; j < c[i]; j++) {
            a[cur++] = v[i];
        }
    }
    set<int> col;
    for (int i = 0; i < v.size(); i++)
        col.insert(v[i]);
    vector<int> colors;
    for (auto a : col)
        colors.push_back(a);
    return find(0, 1 << k, a, -1, colors);
}
int main() {
    ios_base::sync_with_stdio(0);
    int k, n, m;
    cin >> k >> n >> m;
    vector<int> c(n), v(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i] >> v[i];
    }
    cout << stsolve(k, c, v);
    //cout << grsolve(k, c, v);
}
