#include <bits/stdc++.h>
using namespace std;
typedef pair<int, int> pii;

vector<vector<int>> dp;
const int M = 11;
int find(int v, int left, int right, vector<int> &a, int used,
         vector<int> &colors) {
    if (dp[v][used] != -1) return dp[v][used];
    if (right - left == 1) {
        if (a[left] == used) return dp[v][used] = 0;
        else return dp[v][used] = 1;
    }
    int mid = (left + right) / 2;
    dp[v][used] = find(2 * v + 1, left, mid, a, used, colors) + find(2 * v + 2, mid, right, a, used, colors);
    int ans = dp[v][used];
    if (used == 0) {
        for (int i = 0; i < colors.size(); i++) {
            dp[v][colors[i]] = 1 + find(v * 2 + 1, left, mid, a, colors[i], colors)
                      + find(v * 2 + 2, mid, right, a, colors[i], colors);
            ans = min(ans, dp[v][colors[i]]);
        }
    }
    return ans;
}
int stsolve(int k, vector<int> &c, vector<int> &v) {
    vector<int> a(1 << k);
    for (int i = 0, cur = 0; i < v.size(); i++) {
        for (int j = 0; j < c[i]; j++) {
            a[cur++] = v[i];
        }
    }
    dp.resize(1 << (k + 1), vector<int>(M, -1));
    set<int> col;
    for (int i = 0; i < v.size(); i++)
        col.insert(v[i]);
    vector<int> colors;
    for (auto a : col)
        colors.push_back(a);
    return find(0, 0, 1 << k, a, 0, colors);
}
int main() {
    ios_base::sync_with_stdio(0);
    int k, n, m;
    cin >> k >> n >> m;
    vector<int> c(n), v(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i] >> v[i];
    }
    cout << stsolve(k, c, v);
    //cout << grsolve(k, c, v);
}
