#include <bits/stdc++.h>
using namespace std;
typedef pair<int, int> pii;

vector<vector<int>> dp;
vector<int> ans;
const int M = 11;
void find(int v, int left, int right, vector<int> &a, vector<int> &colors) {
    if (right - left > 1) {
        int mid = (left + right) / 2;
        find(2 * v + 1, left, mid, a, colors);
        find(2 * v + 2, mid, right, a, colors);
    }
    for (int i = 0; i < colors.size(); i++) {
        int col = colors[i];
        if (right - left == 1) {
            if (a[left] == col) dp[v][col] = 0;
            else dp[v][col] = 1;
        }
        else dp[v][col] = dp[2 * v + 1][col] + dp[2 * v + 2][col];
        if (col == 0) ans[v] = min(ans[v], dp[v][col]);
        else ans[v] = min(ans[v], dp[v][col] + 1);
        //cout << left << " " << right << " " << col << " " << dp[v][col] << endl;
    }
}
int stsolve(int k, vector<int> &c, vector<int> &v) {
    vector<int> a(1 << k);
    for (int i = 0, cur = 0; i < v.size(); i++) {
        for (int j = 0; j < c[i]; j++) {
            a[cur++] = v[i];
        }
    }
    dp.resize(1 << (k + 1), vector<int>(M, -1));
    ans.resize(1 << (k + 1), (int)1e9);
    set<int> col;
    col.insert(0);
    for (int i = 0; i < v.size(); i++)
        col.insert(v[i]);
    vector<int> colors;
    for (auto a : col)
        colors.push_back(a);
    find(0, 0, 1 << k, a, colors);
    return ans[0];
}
int main() {
    ios_base::sync_with_stdio(0);
    int k, n, m;
    cin >> k >> n >> m;
    vector<int> c(n), v(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i] >> v[i];
    }
    cout << stsolve(k, c, v);
    //cout << grsolve(k, c, v);
}
