#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int, char> pic;
ll inf = 1e18;
/*
ll dfs2(int s, int p, int cur, vector<vector<pic>> &g,
         string &ss, vector<ll> &dp) {
    ll best = inf, val = 0;
    for (auto &a : g[s]) {
        int to = a.first;
        if (to == p) continue;
        val += dp[to];
    }
    if (cur == ss.size()) {
        return min(inf, val);
    }
    for (auto &a : g[s]) {
        int to = a.first;
        if (to == p) continue;
        if (ss[cur] != a.second) continue;
        best = min(best, val - dp[to] +
                   dfs2(to, s, cur + 1, g, ss, dp));
    }
    cout << s << " " << best << " " << val << endl;
    return best;
}

void dfs(int s, int p, vector<vector<pic>> &g,
         vector<int> &w, vector<string> &vs, vector<ll> &dp) {
    for (auto &a : g[s]) {
        int to = a.first;
        if (to == p) continue;
        dfs(to, s, g, w, vs, dp);
    }
    dp[s] = inf;
    for (int i = 0; i < vs.size(); i++) {
        dp[s] = min(dp[s], w[i] + dfs2(s, p, 0, g, vs[i], dp));
    }
}
*/

int main() {
    ios_base::sync_with_stdio(0);
    int n, m, t;
    cin >> n >> m >> t;
    string s;
    for (int i = 0; i < n - 1; i++) {
        int a;
        char c;
        cin >> a >> c;
        s.push_back(c);
    }
    vector<int> w(m);
    vector<string> vs(m);
    bool g1 = true;
    for (int i = 0; i < m; i++) {
        cin >> w[i] >> vs[i];
        if (vs[i].size() > 1) g1 = false;
    }
    if (g1) {
        vector<ll> a(26, inf);
        for (int i = 0; i < m; i++) {
            int cur = vs[i][0] - 'a';
            a[cur] = min(a[cur], (ll)w[i]);
        }
        ll ans = 0;
        for (int i = 0; i < s.size(); i++) {
            int cur = s[i] - 'a';
            if (a[cur] == inf) {
                cout << -1;
                return 0;
            }
            else ans += a[cur];
        }
        cout << ans;
    }
    else {
        vector<ll> dp(s.size() + 1, inf);
        dp.back() = 0;
        vector<vector<int>> pos(s.size());
        for (int i = 0; i < m; i++) {
            string t = vs[i] + '#' + s;
            vector<int> p(t.size());
            for (int i = 1; i < t.size(); i++) {
                int cur = p[i - 1];
                while (cur != 0) {
                    if (t[i] == t[cur]) break;
                    cur = p[cur - 1];
                }
                p[i] = cur;
                if (t[i] == t[cur]) p[i]++;
            }
            /*cout << i << endl;
            for (int i = 0; i < t.size(); i++)
                cout << p[i] << " ";
            cout << endl;*/
            //cout << i << endl;
            for (int j = vs[i].size(); j < t.size(); j++) {
                if (p[j] == vs[i].size()) {
                    pos[j - 2 * vs[i].size()].push_back(i);
                    //cout << j - 2 * vs[i].size() << " ";
                }
            }
            //cout << endl;
        }
        for (int i = s.size() - 1; i >= 0; i--) {
            for (int j = 0; j < pos[i].size(); j++) {
                dp[i] = min(dp[i], w[pos[i][j]] + dp[i + vs[pos[i][j]].size()]);
            }
            for (int j = i + 1; j < dp.size(); j++) {
                dp[j] = min(dp[j], dp[i]);
            }
        }
        if (dp[0] == inf) cout << -1;
        else cout << dp[0];
    }
    /*vector<vector<pic>> g(n);
    vector<int> p(n);
    vector<char> c(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i] >> c[i];
        p[i]--;
        g[p[i]].push_back({ i, c[i] });
        g[i].push_back({ p[i], c[i] });
    }
    vector<int> w(m);
    vector<string> s(m);
    for (int i = 0; i < m; i++) {
        cin >> w[i] >> s[i];
    }
    vector<ll> ans(n);
    dfs(0, -1, g, w, s, ans);
    for (int i = 0; i < n; i++)
        cout << ans[i] << " ";
    cout << endl;
    cout << ans[0];*/
}
