#include <bits/stdc++.h>
using namespace std;
typedef pair<int, int> pii;

struct S {
    int left, right, used;
    bool operator < (const S &s) const {
        return left < s.left || (left == s.left && right < s.right)
        || (left == s.left && right == s.right && used < s.used);
    }
};
unordered_map<S, int> dp;

int find(int left, int right, vector<int> &a, int used) {
    if (dp.count({ left, right, used })) return dp[{ left, right, used }];
    if (right - left == 1) {
        if (a[left] == used) return 0;
        else return 1;
    }
    int mid = (left + right) / 2;
    int ans = find(left, mid, a, used) + find(mid, right, a, used);
    vector<int> cnt(11);
    for (int i = left; i < right; i++) {
        cnt[a[i]]++;
    }
    int best = -1, color;
    for (int i = 1; i < 10; i++) {
        if (best < cnt[i]) best = cnt[i], color = i;
    }
    ans = min(ans, 1 + find(left, mid, a, color) + find(mid, right, a, color));
    return dp[{ left, right, used }] = ans;
}
int stsolve(int k, vector<int> &c, vector<int> &v) {
    vector<int> a(1 << k);
    int sum = 0;
    for (int i = 0, cur = 0; i < v.size(); i++) {
        for (int j = 0; j < c[i]; j++) {
            a[cur++] = v[i];
        }
    }
    dp.reserve(1 << (k + 1));
        /*set<int> col;
    for (int i = 0; i < v.size(); i++)
        col.insert(v[i]);
    vector<int> colors;
    for (auto a : col)
        colors.push_back(a);*/
    return find(0, 1 << k, a, -1);
}
int main() {
    ios_base::sync_with_stdio(0);
    int k, n, m;
    cin >> k >> n >> m;
    vector<int> c(n), v(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i] >> v[i];
    }
    /*srand(time(0));
    int k = 19;
    //cout << (1 << k) << endl;
    int n = 1e5;
    vector<int> c(n), v(n);
    int sum = 0;
    for (int i = 0; i < n - 1; i++) {
        c[i] = rand() % 10;
        v[i] = rand() % 3 + 1;
        sum += c[i];
    }
    c.back() = (1 << k) - sum;
    v.back() = 1;
    int c1 = clock();*/
    cout << stsolve(k, c, v) << endl;
    //int c2 = clock();
    //cout << c2 - c1;
    //cout << grsolve(k, c, v);
}
